diff --git a/fw/hpack.c b/fw/hpack.c
index 881f72e2b..dadff67b8 100644
--- a/fw/hpack.c
+++ b/fw/hpack.c
@@ -2548,6 +2548,57 @@ tfw_hpack_write(const TfwStr *h_field, char *out_buf)
 	return out_buf;
 }
 
+#ifdef DEBUG
+#define T_DBG_PRINT_HPACK_RBTREE(tbl) tfw_hpack_rbtree_print(tbl)
+#else
+#define T_DBG_PRINT_HPACK_RBTREE(tbl)
+#endif
+
+#ifdef DEBUG
+/* Debug functions for printing red-black tree. */
+static void
+tfw_hpack_rbtree_print_level(TfwHPackETbl *__restrict tbl,
+			     TfwHPackNode *__restrict root,
+			     unsigned int level, unsigned int pr_level)
+{
+	if (root && level < pr_level) {
+		TfwHPackNode *left = HPACK_NODE_COND(tbl, root->left);
+		TfwHPackNode *right = HPACK_NODE_COND(tbl, root->right);
+
+		tfw_hpack_rbtree_print_level(tbl, left, level + 1, pr_level);
+		tfw_hpack_rbtree_print_level(tbl, right, level + 1, pr_level);
+	} else if (root) {
+		T_DBG("level (%u): %.*s", level, root->hdr_len, root->hdr);
+	}
+}
+
+static unsigned int
+tfw_hpack_rbtree_cacl_level(TfwHPackETbl *__restrict tbl,
+			    TfwHPackNode *__restrict root)
+{
+	TfwHPackNode *left, *right;
+
+	if (!root)
+		return 0;
+
+	left = HPACK_NODE_COND(tbl, root->left);
+	right = HPACK_NODE_COND(tbl, root->right);
+	return max(tfw_hpack_rbtree_cacl_level(tbl, left),
+		   tfw_hpack_rbtree_cacl_level(tbl, right)) + 1;
+}
+
+static void
+tfw_hpack_rbtree_print(TfwHPackETbl *__restrict tbl)
+{
+	unsigned int level, pr_level =
+		tfw_hpack_rbtree_cacl_level(tbl, tbl->root);
+
+	T_DBG("hpack rbtree:\n");
+	for (level = 0; level < pr_level; ++level)
+		tfw_hpack_rbtree_print_level(tbl, tbl->root, 0, level);
+}
+#endif
+
 /*
  * Left rotation of red-black tree.
  */
@@ -3820,6 +3871,7 @@ tfw_hpack_encode(TfwHttpResp *__restrict resp, TfwStr *__restrict hdr,
 
 	T_DBG3("%s: op=%d, st_index=%hu, st_full_index=%d\n", __func__, op,
 	       st_index, st_full_index);
+	T_DBG_PRINT_HPACK_RBTREE(tbl);
 
 	if (!st_full_index && dyn_indexing) {
 		r = tfw_hpack_encoder_index(tbl, hdr, &index, resp->flags, op);
